import Vue from "vue";
import Vuex from "vuex";
import { login } from "../api/user";
import { setStore, clearStore } from "@/utils/store";
import { setToken, removeToken } from "@/utils/auth";

Vue.use(Vuex);

export default new Vuex.Store({
  state: {
    userInfo: "",
    token: ""
  },
  mutations: {
    SET_TOKEN: (state, token) => {
      setToken(token);
      state.token = token;
      setStore({ name: "token", content: state.token, type: "session" });
    },
    SET_USERIFNO: (state, userInfo) => {
      state.userInfo = userInfo;
      setStore({ name: "userInfo", content: state.userInfo });
    }
  },
  actions: {
    login_username({ commit }, userInfo) {
      return new Promise((resolve, reject) => {
        login(userInfo.username, userInfo.password)
          .then(res => {
            console.log(res.obj[0].token);
            const token = res.obj[0].token;
            const userInfo = res.obj[0];
            // console.log(token, userInfo);
            commit("SET_TOKEN", token);
            commit("SET_USERIFNO", userInfo);
            resolve();
          })
          .catch(err => {
            reject(err);
          });
      });
    },
    // 登出
    loginOut({ commit }) {
      return new Promise((resolve, reject) => {
        // logout().then(() => {
        commit("SET_TOKEN", "");
        commit("SET_USERIFNO", []);
        removeToken();
        clearStore();
        resolve()
          // })
          .catch(error => {
            reject(error);
          });
      });
    }
  },
  modules: {}
});
